import sys
import re
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"ironworks.pmh",
				"ChainOp",
				"WayPathOp",
				"WayPointOp",
				"WayRestraintOp",
				"ironworksDL" ]

	manifest = 'ext/ironworks/manifest.cc'
	with open(manifest, 'w') as outfile:
		outfile.write("")
	for src in srcList:
			if re.compile(r'(.*)Op$').match(src):
				with open(manifest, 'a') as outfile:
					outfile.write('\tspManifest->catalog<String>(\n'+
							'\t\t\t"OperatorSurfaceI.' + src + '.fe")='+
							'"fexIronWorksDL";\n');

	dll = module.DLL( "fexIronWorksDL", srcList )

	deplibs = forge.corelibs + [
				"fexGeometryDLLib",
				"fexMathLib",
				"fexOperateDLLib",
				"fexSurfaceDLLib",
				"fexWindowLib"	]

	forge.deps( ["fexIronWorksDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",	"fexIronWorksDL",					None,	None) ]
