/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "lua.pmh"
#include "platform/dlCore.cc"

using namespace fe;

extern "C"
{

FE_DL_EXPORT void ListDependencies(List<String*>& list)
{
}

FE_DL_EXPORT Library* CreateLibrary(sp<Master>)
{
	Library *pLibrary = new Library();
	pLibrary->add<LuaBind>("HandlerI.LuaBind.fe");
	pLibrary->add<LuaHandler>("LuaI.LuaHandler.fe");
	pLibrary->add<LuaIterate>("HandlerI.LuaIterate.fe");
	pLibrary->add<SurfaceAccessibleLua>(
			"SurfaceAccessibleI.SurfaceAccessibleLua.fe.lua");
	return pLibrary;
}

FE_DL_EXPORT void InitializeLibrary(sp<Library> spLibrary)
{
}

}
